Subject: Re: [PATCH] uapi: fix linux/if.h userspace compilation errors

From: "Dmitry V. Levin" <[email-masked]>
Date: Wed, 22 Feb 2017 05:22:59 +0300

On Tue, Feb 21, 2017 at 11:19:14PM +0300, Dmitry V. Levin wrote:
> On Tue, Feb 21, 2017 at 12:10:22PM -0500, David Miller wrote:
> > From: "Dmitry V. Levin" <[email-masked]>
> > Date: Mon, 20 Feb 2017 14:58:41 +0300
> > 
> > > Include <sys/socket.h> (guarded by ifndef __KERNEL__) to fix
> > > the following linux/if.h userspace compilation errors:
> > 
> > Wouldn't it be so much better to do this in include/uapi/linux/socket.h?
[...]
> We can try to workaround these ancient <time.h> against <linux/time.h>
> and <sys/uio.h> against <linux/uio.h> conflicts on uapi side by
> introducing __UAPI_DEF_TIMESPEC, __UAPI_DEF_TIMEVAL, and __UAPI_DEF_IOVEC
> guards, but these workarounds will work only one way (when libc headers
> are included before uapi ones) until glibc catches up, and the latter
> may take a lot of time.

OK, these conflicts need to be fixed regardless of the way how
struct sockaddr related uapi compilation errors are fixed.
I'll submit these fixes shortly.

-- 
ldv